/**
 * Example file for demonstrating the ALE transmitter functionality.
 *
 * @author  Ehsan Tofigh
 * @project lcx
 * @file    src/examples/ale_tx/main.c
 * @license
 */

#include <libradio/ale.h>
#include <libcortex/nvic.h>
#include <libcortex/radio.h>
#include <libcortex/systick.h>

#include <stdbool.h>
#include <stdint.h>

/** Configuration structure for the ALE module. */
static const struct lrd_ale_handle handle = {
	.key = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 0xA, 0xB, 0xC, 0xD, 0xE, 0xF },
};

struct {
	struct lrd_ale_header header;
	char   payload[12U];
} __attribute__((packed)) packet = {
	.payload = "Hello World!",
	.header.length = sizeof(packet.payload),
};

/**
 * Entry point of program.
 *
 * @return Return code of the program.
 */
int main (void)
{
	(void) lcx_nvic_init(1U);
	(void) lrd_ale_init(&handle);

	while (true) {
		(void) lrd_ale_transmit(&packet.header, sizeof(packet), false);
		lcx_systick_sleep_ms(1000U);
	}

	return 0;
}
